/**
*Buzz Chess Engine
*moveordering.h
*
*Header for functions related to move ordering.
*
*Copyright (C) 2007 Pradu Kannan
**/

#include "defs.h"
#include "board.h"
#include "movegen.h"
#include "hash.h"
/*
*Build Configuration
*/

#define SEE_CAPTURE_ONLY
//#define USE_NULL_KILLER
#define TWO_KILLERS
//set MO_CHECK if move checks
//#define CHECK_FLAG

/*
*Definitions
*/

#define MOVEORDERING_HASHMOVE   2147483647
#define MOVEORDERING_CAPTURE    2147400000
#define MOVEORDERING_NULLKILLER 2147300004
#define MOVEORDERING_KILLER     2147300002
#define MOVEORDERING_KILLER2    2147300000

//#define MOVEORDERING_EQUALCAP   2147300002//2147200004

#define MOVEORDERING_PASSER     2147200002
#define MOVEORDERING_ATTACKWEAK 2147200001
#define MOVEORDERING_MAXHIST    2147200000

#define MOVEORDERING_GOODMOVE   2147200000 /*All values above this are good moves to search*/
#define MOVEORDERING_CHECK      2147200003
#define MOVEORDERING_CASTLING            2 /*Bonus*/

//Extra info added to the move when ordered
#define MO_PASSER 1
#define MO_CHECK  2
#define MO_CHECKEVASION 4
#define MO_CAPTURE 8
#define MO_BADSEE 16

/*
*Function Prototypes
*/

void orderMoves(const board* pos, moveList* ml, int dfr,move hashMove);
void orderQMoves(const board* pos, moveList* ml);
void orderQCMovesnu(const board* pos, moveList* ml);
void sortMoveList(moveList* ml);
void storeKiller(const move m, const int dfr);
move nextmove(moveList *ml,int *score);
#ifdef USE_NULL_KILLER
void storeNullKiller(const move m, const int dfr);
#endif
void clearHistory(void);
void clearKillers(void);
int SEE(const board* pos, const move m);
void clearMoveOrderingData();
//storeGoodMove: this is just storeHistory and storeKiller folded together for efficiency
void storeGoodMove(const move m,const int depth,const int side,const int dfr);
void AdjustMoveScore(const move m, const int depth, const int side);
void updatecount(move m,int side);
bool was_searched(move m,int side);
bool looks_lousy(move m,int depth,int side);
