/**
*Buzz Chess Engine
*nalimov.h
*
*Probes Nalimov endgame tablebases.
*
*Copyright (C) 2008 Pradu Kannan. All rights reserved.
**/

#ifndef _nalimovh
#define _nalimovh

/*
*Dependancies
*/

#include "defs.h"

/*
*Function Prototypes
*/
extern int initNalimov(char* path, unsigned long cache_size); //returns true on success

/**
 * Probe Nalimov
 * returns true on hit
 * The value placed in score is as follows, where STM is the side to move:
 *        3   STM mates in 3, etc.
 *        2   STM mates in 2.
 *        1   STM mates in 1.
 *        0   Draw.
 *       -1   STM is checkmated.
 *       -2   STM mated in 1.
 *       -3   STM mated in 2, etc.
 */
extern int probeNalimov(const board* const pos, int* result);


void finalizeNalimov();

/*
*Data
*/

extern int NalimovNumPieces;

#endif //_nalimovh