/**
*Buzz Chess Engine
*recog.c
*
*Recognizes the reuslt of a position using endgame tablebases,
*endgame bitbases, and/or recognizers and can provide a bound
*on true value of a position.
*
*Copyright (C) 2008 Pradu Kannan. All rights reserved.
**/

#include "recog.h"
#include "nalimov.h"
#include "eval.h"

/*
*Data
*/

unsigned int NalimovEGTBCache = 16*1024*1024;

char NalimovEGTBPath[4096] = "" /*"G:/3;G:/4"*/;

/*
*Functions
*/
#ifdef NALIMOV
int recog(const board* const pos, int* const LB, int* const UB, const int dfr)
{
	int num_pieces = matsig_getAll(pos->matsig);
	//Nalimov endgame tablebases
	if(num_pieces<=NalimovNumPieces)
	{
		int result = 0;
		if(probeNalimov(pos,&result)){
			//Convert to a Buzz mate score
			if(result>0) result = MATE-dfr-(2*result-1);
			else if (result<0) result = -(MATE-dfr+2*(result+1));
			*LB = result;
			*UB = result;
			return 1;
		}
	}
	return 0;
}
#endif