/**
*Buzz Chess Engine
*recog.h
*
*Recognizes the reuslt of a position using endgame tablebases,
*endgame bitbases, and/or recognizers and can provide a bound
*on true value of a position.
*
*Copyright (C) 2008 Pradu Kannan. All rights reserved.
**/

#ifndef _egtbh
#define _egtbh

/*
*Dependancies
*/

#include "defs.h"
#include "board.h"

/*
*Build Configuration
*/

//What kind of tablebase are we using?
#define NALIMOV

/*
*Definitions
*/

#ifdef NALIMOV
# define DTM  /* depth to mate tablebase */
# define DEFAULT_NALIMOV_PATH ""
# define DEFAULT_NALIMOV_CACHE (16*1024*1024)
#endif

/*
*Function Prototypes
*/

/**
* returns true on a tablebase/recognizer hit
* pos - board position
* LB - returned lower bound socre on position
* UB - returned upper bound score on position
* dfr - depth from root
*/
#ifdef NALIMOV
int recog(const board* const pos, int* const LB, int* const UB, const int dfr);
#endif
/*
*Data
*/

extern unsigned int NalimovEGTBCache;
extern char NalimovEGTBPath[4096];

#endif //_egtbh